portal = context.getPortalObject()

consuming_analysis_list_dict = {}

def add_consuming_analysis(producing_analysis_relative_url, consuming_analysis_relative_url):
  consuming_analysis_list = consuming_analysis_list_dict.setdefault(producing_analysis_relative_url, [])
  consuming_analysis_list.append(consuming_analysis_relative_url)

analysis_list = []
for analysis in portal.portal_catalog(portal_type = "Data Analysis",
                                           simulation_state = "started"):
  has_transient_input = False
  for line in analysis.objectValues(portal_type="Data Analysis Line"):
    if line.getUse() == "big_data/analysis/transient" and line.getQuantity() < 0:
      has_transient_input = True
      add_consuming_analysis(line.getParentValue().getCausality(), line.getParentRelativeUrl())
  if not has_transient_input:
    analysis_list.append(analysis)

for analysis in analysis_list:
  if not analysis.hasActivity():
    consuming_analysis_list = consuming_analysis_list_dict.get(analysis.getRelativeUrl(), [])
    analysis.activate(serialization_tag=str(analysis.getUid()))\
      .DataAnalysis_executeDataOperation(consuming_analysis_list)
